import java.util.*;
import java.io.*;

// Задача "Преобразователь строк"
// 12-ая Интернет-олимпиада сезона 2006-2007, базовый уровень
// Автор задачи: Федор Царев, tsarev@rain.ifmo.ru
// Автор решения: Максим Буздалов, buzdalov@rain.ifmo.ru

// Решение с обычной сортировкой за время n log n.

public class morpher_mb_slow {
    public static void main(String[] args) throws IOException {
        Scanner in = new Scanner(new File("morpher.in"));
        char[] smb = in.next().toCharArray();
        int cnt = in.nextInt();
        for (int ct = 0; ct < cnt; ct++) {
            if (in.next().equals("R")) {
                int left = in.nextInt() - 1;
                int right = in.nextInt() - 1;
                for (int i = left, j = right; i < j; i++, j--) {
                    char t = smb[i]; 
                    smb[i] = smb[j];
                    smb[j] = t;
                }
            } else {
                int left = in.nextInt() - 1;
                int right = in.nextInt() - 1;
                Arrays.sort(smb, left, right + 1);                
            }
        }
        in.close();

        PrintWriter out = new PrintWriter("morpher.out");
        out.println(smb);
        out.close();
    }
}